using System;
using System.Collections.Generic;
using System.Linq;
using System.Data;
using AvaloniaApplication5.Models;
using Microsoft.EntityFrameworkCore;
using ReactiveUI;
using System.Text;
using System.Threading.Tasks;
using MsBox.Avalonia.Enums;
using MsBox.Avalonia;

namespace AvaloniaApplication5.ViewModels
{
	internal class AddPageViewModel : ViewModelBase
    {
		Teacher? _newTeacher;
         public Teacher? NewTeacher { get => _newTeacher; set => this.RaiseAndSetIfChanged(ref _newTeacher, value); }
	   
	     public List<TeacherCourse> TeacherCourses { get => _teacherCourses; set => this.RaiseAndSetIfChanged(ref _teacherCourses, value); }
      public AddPageViewModel()
		{
			_newTeacher = new Teacher()
			{
				Gender = new Gender() 
			};
            TextButton = "";
        }
	   string text_button = "";
		public string TextButton
		{
			get {  return text_button; }
			set { this.RaiseAndSetIfChanged(ref text_button, value); }
		}
		public AddPageViewModel(int idt)
		{
			_newTeacher = MainWindowViewModel.myConnection.Teachers.Include(x=>x.Gender).Include(x=>x.TeacherCourses).ThenInclude(x=>x.Course).Include(x=>x.TeacherDisciplines).ThenInclude(x=>x.Discipline).FirstOrDefault(x=>x.Id == idt);
            TeacherCourses = NewTeacher.TeacherCourses.ToList();
			TeacherDisciplines = NewTeacher.TeacherDisciplines.ToList();
			
				TextButton = " ";
			
		}
	    public List<Gender> Genders => MainWindowViewModel.myConnection.Genders.ToList();
	    public List<Discipline> Disciplines => MainWindowViewModel.myConnection.Disciplines.ToList().Except(_newTeacher.TeacherDisciplines.Select(x =>x.Discipline)).ToList();
	    public List<Course> Courses => MainWindowViewModel.myConnection.Courses.ToList().Except(_newTeacher.TeacherCourses.Select(x => x.Course)).ToList();

		public List<TeacherDiscipline> TeacherDisciplines { get => _teacherDisciplines; set => this.RaiseAndSetIfChanged(ref _teacherDisciplines, value); }
	
		List<TeacherCourse>? _teacherCourses;
		List<TeacherDiscipline>? _teacherDisciplines;
		
		Course? selectedCourse;
		Discipline? selectedDiscipline;
	    public Course? SelectedCourse
		{
			get => null;
			set
			{
				if(value != null)
				{
					NewTeacher.TeacherCourses.Add(new TeacherCourse()
					{
						Teacher = NewTeacher, Course = value
					});
					TeacherCourses = NewTeacher.TeacherCourses.ToList();
					this.RaisePropertyChanged(nameof(Courses));
				}
			}
		}
		public Discipline? SelectedDiscipline
		{
			get => null;
			set
			{
				if (value != null)
				{
					NewTeacher.TeacherDisciplines.Add(new TeacherDiscipline()
					{
						Teacher = NewTeacher, Discipline = value
					});
					TeacherDisciplines = NewTeacher.TeacherDisciplines.ToList();
					this.RaisePropertyChanged(nameof(Disciplines));
				}
			}
		}

       

		public void DeleteDiscipline(TeacherDiscipline teacherDiscipline)
		{
			NewTeacher.TeacherDisciplines.Remove(teacherDiscipline);
			TeacherDisciplines = NewTeacher.TeacherDisciplines.ToList();
            this.RaisePropertyChanged(nameof(Disciplines));
        }
        public void DeleteCourse(TeacherCourse teacherCourse)
        {
            NewTeacher.TeacherCourses.Remove(teacherCourse);
            TeacherCourses = NewTeacher.TeacherCourses.ToList();
            this.RaisePropertyChanged(nameof(Courses));
        }

        public async void  AddTeacher()
		{
			
			if (NewTeacher.Id == 0 && TextButton == "")

            {
               ButtonResult result = await MessageBoxManager.GetMessageBoxStandard(" ",
               "  ?", ButtonEnum.YesNo).ShowAsync();
			   if (result == ButtonResult.Yes)
			   {

                    MainWindowViewModel.myConnection.Teachers.Add(NewTeacher);
                    await MessageBoxManager.GetMessageBoxStandard("", " ", ButtonEnum.Ok).ShowAsync();

               }
				else
				{
                    await MessageBoxManager.GetMessageBoxStandard("", " ", ButtonEnum.Ok).ShowAsync();
                }
				
			}

			else { 
                ButtonResult result = await MessageBoxManager.GetMessageBoxStandard(" ",
              "  ?", ButtonEnum.YesNo).ShowAsync();
                if (result == ButtonResult.Yes)
                {

                   
                    await MessageBoxManager.GetMessageBoxStandard("", " ", ButtonEnum.Ok).ShowAsync();

                }
                else
                {
                    await MessageBoxManager.GetMessageBoxStandard("", " ", ButtonEnum.Ok).ShowAsync();
                }

            }
			MainWindowViewModel.myConnection.SaveChanges();
            MainWindowViewModel.Instance.PageContent = new Show();
        }
        public void ToAddDisCurs()
        {
            MainWindowViewModel.Instance.PageContent = new AddDisCurs();
        }
        string _message = "";

        public string Message
        {
            get => _message;
            set => this.RaiseAndSetIfChanged(ref _message, value);
        }

        

    }
}