﻿using Avalonia.Controls;
using AvaloniaApplication5.Models;
using ReactiveUI;

namespace AvaloniaApplication5.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        public static MainWindowViewModel Instance; // переменная для обращения к классу MainWindowViewModel из других классов

        // переменная для обращения к базе данных (TextBaseContext - класс, который автоматически создается при подключении БД к проекту,
        // и в котором находятся все необходимые ссылки для подключения БД)
        public static _43pBezaevaContext myConnection = new _43pBezaevaContext();

        public MainWindowViewModel()
        {
            Instance = this;  // инициализация переменной для обращения к классу MainWindowViewModel из других классов
        }

        UserControl _pageContent = new Show(); // переменная для смемы страниц


        public UserControl PageContent // свойство для манипулирования переменной для смены страниц
        {
            get => _pageContent;
            set => this.RaiseAndSetIfChanged(ref _pageContent, value);
        }
    }
}
